#version 330
layout(location = 0) out vec4 out_color;

uniform vec3 light_position;
uniform vec3 eye_position;
uniform int material_shininess;
uniform float material_kd;
uniform float material_ks;

const vec3 ambinet = vec3(0.90,0.0,0.20);
//const vec3 Kd = vec3(0.30,0.80,0.10);

in vec3 world_pos;
in vec3 world_normal;

const int levels = 5;
const float scaleFactor = 1.0 / levels;

void main(){
	vec3 color= vec3(0.90,0.0,0.20);

	vec3 Kd = vec3(0.30,0.80,0.10);
	
	vec3 L = normalize( light_position - world_pos);
	vec3 V = normalize( eye_position - world_pos);

	float difuza = max(0, dot(L,world_normal));
	Kd = Kd * material_kd* floor(difuza * levels) * scaleFactor;

	vec3 H = normalize(L + V);

	float speculara = 0;

	if( dot(L,world_normal) > 0.0)
	{
         speculara = material_ks * pow( max(0, dot( H, world_normal)), material_shininess);
		 
	}	
	
	float specMask = (pow(dot(H, world_normal), material_shininess) > 0.4) ? 1 : 0;
	float edgeMask = (dot(V, world_normal) >  0.2) ? 1 : 0;
	
	color = edgeMask * (color + Kd + speculara * specMask);

	out_color = vec4(color,1);
}